import greenfoot.*;

/**
 * @author Devin Magee
 * @version 1.00
 */
public class Space extends World
{
    private Player player;
    Counter counter = new Counter();
        
    public Space()
    {           
        super(650, 550, 1); 
        player = new Player();
        addObject(player, getWidth() / 2, getHeight()-40);
        addObject(counter, 110,15);
    }
    
    public Counter getCounter()
    {
        return counter;
    }
    
    public void act() {
        checkForKeyPress();
        addInvader();
        flyingByStars();
    }
    
    private void addInvader() {
        int rnd = Greenfoot.getRandomNumber(900);
        int invaderCount = getObjects(Asteroid.class).size();
        
        if (rnd < 40 && invaderCount < 6) {
            rnd = Greenfoot.getRandomNumber(getWidth());
            addObject(new Asteroid(),rnd, 0);
        }
    }
    
    private void flyingByStars() {
        int rnd = Greenfoot.getRandomNumber(900);
        int starCount = getObjects(Stars.class).size();
        
        if (rnd < 5 && starCount < 18) {
            rnd = Greenfoot.getRandomNumber(getWidth());
            addObject(new Stars(), rnd, 0);
        }
    }
    
    int shootTime = 0;
    int shootDelay = 150;
    
    private void checkForKeyPress() {
        
        if(Greenfoot.isKeyDown("space") && shootTime > shootDelay) 
        {
            int x = player.getX();
            int y = player.getY();
            addObject(getLaser(2), x - 22, y - 10);
            addObject(getLaser(2), x + 24, y - 10);
            shootTime = 0;
        }
        else 
        {
            shootTime++;
        }
        
    }
        

    private Laser getLaser(int factor) {
        Laser laser = new Laser();
        GreenfootImage img = laser.getImage();
        img.scale(img.getWidth()/factor, img.getHeight()/factor);
        laser.setImage(img);
        return laser;
    }
}








